--[[
	* Copyright (c) 2020 by Antoine Desmarets.
	* Cixi of Remulos Oceanic / WoW Classic
	*
	* ClassicGoals is distributed in the hope that it will be useful and entertaining,
	* but WITHOUT ANY WARRANTY
]]--


local cglocal_version = "1.13.6.103"  --change here, and in TOC
local cglocal_reqPrefix = "ClassicGoals;"

local _G = getfenv(0)

local cglocal_goals = {}

local cglocal_frames = {} 			--frames created (to reuse them later)
local cglocal_selectedframes = {} 	--frames created (to reuse them later) - tab1
local cglocal_addframes = {}		--frames created (to reuse them later) - tab2
local cglocal_addoptionsframes = {}	--frames created (to reuse them later) - tab2options

local cglocal_noHighlighting = true -- prevent highlighting of listed goals on tab1
local cglocal_noTooltip = false 	-- prevent tooptips when customizing new goal
local cglocal_disableSave = true 	-- prevent the save button from being greyed

local cglocal_moneyBefore = 0		-- to calculate the amount looted
local cglocal_moneyAmount = 0		-- amount looted

local cglocal_ticker				-- used to calculate played time
local cglocal_freq = 10				-- we don't need to check every sec

local cglocal_editXXX
local cglocal_editYYY				-- hold the components for edits
local cglocal_editYYY1				-- YYY1 needed for checkboxes
local cglocal_editYYY2
local cglocal_editYYY3
local cglocal_editYYY4
local cglocal_editZZZ

local cglocal_editselid = nil		-- id of the edited goal

local cglocal_goals = {}
-- available goals -- type (A:Account/C:Character) / Title / Description
table.insert(cglocal_goals,	{ Id = 1,  Type = "A", Title = "Have XXX level YYY characters.", Desc = "Have at least that number of characters at that level on this account.", Icon = "Interface\\Icons\\inv_misc_food_10", XXX = "number", YYY = "level", XXXdef = 4, YYYdef = 60 })
table.insert(cglocal_goals,	{ Id = 8,  Type = "A", Title = "Level XXX times.", Desc = "Have at least that number of cumulated levels on this account.", Icon = "Interface\\Icons\\inv_misc_food_10", XXX = "number", XXXdef = 300})
table.insert(cglocal_goals,	{ Id = 2,  Type = "A", Title = "Make XXX gold.", Desc = "Generate, via any mean, that amount of cumulated gold across all your characters.", Icon = "Interface\\Icons\\inv_misc_coin_01", XXX = "amount", XXXdef = 1000 })
table.insert(cglocal_goals,	{ Id = 3,  Type = "A", Title = "Loot XXX gold.", Desc = "Generate, via looting, that amount of cumulated gold across all your characters.", Icon = "Interface\\Icons\\inv_misc_coin_01", XXX = "amount", XXXdef = 500  })
table.insert(cglocal_goals,	{ Id = 4,  Type = "A", Title = "Have XXX gold.", Desc = "Have that amount of gold across all characters on this account.", Icon = "Interface\\Icons\\inv_misc_coin_01", XXX = "amount", XXXdef = 5000  })
table.insert(cglocal_goals,	{ Id = 5,  Type = "A", Title = "Reach XXX YYY of cumulated playtime.", Desc = "Reach that amount of playtime across all characters on this account.", Icon = "Interface\\Icons\\spell_nature_timestop", XXX = "number", YYY = "days/hours", XXXdef = 20, YYYdef = "days"  })
table.insert(cglocal_goals,	{ Id = 11, Type = "A", Title = "Get the Riding skill on XXX characters.", Desc = "Get your level 40 riding skill on a number of toons.", Icon = "Interface\\Icons\\spell_nature_swiftness", XXX = 'number', XXXdef = 4 })
table.insert(cglocal_goals,	{ Id = 12, Type = "A", Title = "Get the Epic Riding skill on XXX characters.", Desc = "Get your level 60 epic riding skill on a number of toons.", Icon = "Interface\\Icons\\spell_nature_swiftness", XXX = 'number', XXXdef = 4  })
table.insert(cglocal_goals,	{ Id = 9,  Type = "A", Title = "Kill XXX mobs.", Desc = "Kill that amount of enemies across all your characters.", Icon = "Interface\\Icons\\spell_shadow_shadowwordpain", XXX = "number", XXXdef = 5000  })
table.insert(cglocal_goals,	{ Id = 10, Type = "A", Title = "Kill YYY, XXX times.", Desc = "Kill that specific mob that many times across all your characters.", Icon = "Interface\\Icons\\spell_shadow_shadowwordpain", YYY = "mob", XXX = "number", YYYdef = "Ragnaros", XXXdef = 50  })
table.insert(cglocal_goals,	{ Id = 6,  Type = "A", Title = "Get XXX honorable kills in PVP.", Desc = "Get to that amount of HKs across all characters on this account.", Icon = "Interface\\Icons\\ability_warrior_challange", XXX = "number", XXXdef = 5000  })
table.insert(cglocal_goals,	{ Id = 7,  Type = "A", Title = "Get XXX dishonorable kills in PVP.", Desc = "Get to that amount of DKs across all characters on this account.", Icon = "Interface\\Icons\\ability_warrior_challange", XXX = "number", XXXdef = 10  })


table.insert(cglocal_goals,	{ Id = 101, Type = "C", Title = "Reach level XXX.", Desc = "Make it to that level or higher.", Icon = "Interface\\Icons\\inv_misc_food_10", XXX = "level", XXXdef = 60  })
--table.insert(cglocal_goals,	{ Id = 102, Type = "C", Title = "Reach level XXX under ZZZ YYY.", Desc = "Make it to that level or higher under the specified playtime.", Icon = "Interface\\Icons\\inv_misc_food_10", XXX = "level", ZZZ = "number", YYY = "days/hours", XXXdef = 10, ZZZdef = 4, YYYdef = "hours"  })
table.insert(cglocal_goals,	{ Id = 103, Type = "C", Title = "Make XXX gold.", Desc = "Generate, via any mean, that amount of gold on this character.", Icon = "Interface\\Icons\\inv_misc_coin_02", XXX = "amount", XXXdef = 100  })
table.insert(cglocal_goals,	{ Id = 104, Type = "C", Title = "Loot XXX gold.", Desc = "Generate, via looting only, that amount of gold on this character.", Icon = "Interface\\Icons\\inv_misc_coin_02", XXX = "amount", XXXdef = 50 })
table.insert(cglocal_goals,	{ Id = 105, Type = "C", Title = "Have XXX gold.", Desc = "Have that amount of gold on this character.", Icon = "Interface\\Icons\\inv_misc_coin_02", XXX = "amount", XXXdef = 1000  })
table.insert(cglocal_goals,	{ Id = 112, Type = "C", Title = "Reach XXX YYY of playtime.", Desc = "Reach that amount of playtime on this character.", Icon = "Interface\\Icons\\spell_nature_timestop", XXX = "number", YYY = "days/hours", XXXdef = 240, YYYdef = "hours"  })
table.insert(cglocal_goals,	{ Id = 115, Type = "C", Title = "Get the Riding skill.", Desc = "Get your level 40 riding skill.", Icon = "Interface\\Icons\\spell_nature_swiftness" })
table.insert(cglocal_goals,	{ Id = 116, Type = "C", Title = "Get the Epic Riding skill.", Desc = "Get your level 60 epic riding skill.", Icon = "Interface\\Icons\\spell_nature_swiftness" })
table.insert(cglocal_goals,	{ Id = 106, Type = "C", Title = "Defeat YYY.", Desc = "Get this character to kill that boss.", Icon = "Interface\\Icons\\spell_shadow_shadowwordpain", YYY = "boss", YYYdef = "Nefarian"  })
table.insert(cglocal_goals,	{ Id = 113, Type = "C", Title = "Kill XXX mobs.", Desc = "Kill that amount of enemies.", Icon = "Interface\\Icons\\spell_shadow_shadowwordpain", XXX = "number",  XXXdef = 1000 })
table.insert(cglocal_goals,	{ Id = 114, Type = "C", Title = "Kill YYY, XXX times.", Desc = "Kill that specific mob that many times across all your characters.", Icon = "Interface\\Icons\\spell_shadow_shadowwordpain", YYY = "mob", XXX = "number", YYYdef = "Nefarian", XXXdef = "10"  })
table.insert(cglocal_goals,	{ Id = 107, Type = "C", Title = "Reach YYY with XXX.", Desc = "Reach that reputation level or higher.", Icon = "Interface\\Icons\\inv_misc_note_02.png", XXX = "faction", YYY = "rep level", XXXdef = "Hydraxian Waterlords", YYYdef = "Exalted", ZZZdef = 42000   })
table.insert(cglocal_goals,	{ Id = 108, Type = "C", Title = "Obtain YYY.", Desc = "Get your hands on that item.", Icon = "Interface\\Icons\\inv_hammer_unique_sulfuras", YYY = "item", XXX = "item id", XXXdef = 17182, YYYdef = "|cffff8000|Hitem:17182::::::::5:::::::|h[Sulfuras, Hand of Ragnaros]|h|r", ZZZdef = "Sulfuras, Hand of Ragnaros"  })
table.insert(cglocal_goals,	{ Id = 109, Type = "C", Title = "Reach rank XXX in PVP.", Desc = "Get this character to that PVP rank.", Icon = "Interface\\Icons\\ability_warrior_challange", XXX = "rank", XXXdef = 10 })
table.insert(cglocal_goals,	{ Id = 110, Type = "C", Title = "Get XXX honorable kills in PVP.", Desc = "Get to that amount of HKs on this character.", Icon = "Interface\\Icons\\ability_warrior_challange", XXX = "number", XXXdef = 1000 })
table.insert(cglocal_goals,	{ Id = 111, Type = "C", Title = "Get XXX dishonorable kills in PVP.", Desc = "Get to that amount of DKs on this character.", Icon = "Interface\\Icons\\ability_warrior_challange", XXX = "number", XXXdef = 1  })

local cglocal_addgoal = {}

local cglocal_replevels = 	{ 	{"Hated", 		-42000	},
								{"Hostile", 	-6000	},
								{"Unfriendly", 	-3000	},
								{"Neutral", 	0 		},
								{"Friendly", 	3000	},
								{"Honored", 	9000	},
								{"Revered", 	21000	},
								{"Exalted", 	42000	}
							}


local cglocal_reputations = { 	
								{"Zandalar Tribe"},
								{"Wintersaber Trainers"}, 
								{"Wildhammer Clan"},
								{"Warsong Outriders"},
								{"Undercity"},							
								{"Timbermaw Hold"},
								{"Thunder Bluff"},
								{"Thorium Brotherhood"},
								{"The League of Arathor"},
								{"The Defilers"},
								{"Syndicate"},
								{"Stormwind"},
								{"Stormpike Guard"},
								{"Steamwheedle Cartel"},
								{"Silverwing Sentinels"},
								{"Shen'dralar"},
								{"Ravenholdt"},
								{"Ratchet"},
								{"Orgrimmar"},
								{"Magram Clan Centaur"},
								{"Ironforge"},
								{"Hydraxian Waterlords"},
								{"Horde"},
								{"Gnomeregan Exiles"},
								{"Gelkis Clan Centaur"},
								{"Gadgetzan"},
								{"Frostwolf Clan"},
								{"Everlook"},
								{"Darnassus"},
								{"Darkspear Trolls"},
								{"Darkmoon Faire"},
								{"Cenarion Circle"},
								{"Brood of Nozdormu"},
								{"Booty Bay"},
								{"Bloodsail Bucaneers"},
								{"Argent Dawn"},
								{"Alliance"},
							}



local cglocal_bosses = 	{ 	
							{"World Bosses", "Azuregos"},
							{"World Bosses", "Teremus the Devourer"},
							{"World Bosses", "Doom Lord Kazzak"},
							{"World Bosses", "Emeriss"},
							{"World Bosses", "Lethon"},
							{"World Bosses", "Ysondre"},
							{"World Bosses", "Taerar"},
							{"World Bosses", "Omen"},
							{"World Bosses", "Prince Thunderaan"},
							{"World Bosses", "Hogger"},
							{"World Bosses", "Gamon"},
							{"Molten Core", "Lucifron"},
							{"Molten Core", "Magmadar"},
							{"Molten Core", "Gehennas"},
							{"Molten Core", "Garr"},
							{"Molten Core", "Baron Geddon"},
							{"Molten Core", "Shazzrah"},
							{"Molten Core", "Sulfuron Harbinger"},
							{"Molten Core", "Golemagg the Incinerator"},
							{"Molten Core", "Majordomo Executus"},
							{"Molten Core", "Ragnaros"},
							{"Onyxia's Lair", "Onyxia"},
							{"Blackwing Lair", "Razorgore the Untamed"},
							{"Blackwing Lair", "Vaelastrasz the Corrupt"},
							{"Blackwing Lair", "Broodlord Lashlayer"},
							{"Blackwing Lair", "Firemaw"},
							{"Blackwing Lair", "Ebonroc"},
							{"Blackwing Lair", "Flamegor"},
							{"Blackwing Lair", "Chromaggus"},
							{"Blackwing Lair", "Nefarian"},
							{"Zul'Gurub", "High Priestess Jeklik"},
							{"Zul'Gurub", "High Priest Venoxis"},
							{"Zul'Gurub", "High Priestess Mar'li"},
							{"Zul'Gurub", "High Priest Thekal"},
							{"Zul'Gurub", "High Priestess Arlokk"},
							{"Zul'Gurub", "Bloodlord Mandokir"},
							{"Zul'Gurub", "Jin'do the Hexxer"},
							{"Zul'Gurub", "Gahz'ranka"},
							{"Zul'Gurub", "Gri'lek"},
							{"Zul'Gurub", "Hazza'rah"},
							{"Zul'Gurub", "Renataki"},
							{"Zul'Gurub", "Wushoolay"},
							{"Zul'Gurub", "Hakkar the Soulflayer"},
							{"Ruins of Ahn'Qiraj", "Kurinnaxx"},
							{"Ruins of Ahn'Qiraj", "General Rajaxx"},
							{"Ruins of Ahn'Qiraj", "Moam"},
							{"Ruins of Ahn'Qiraj", "Buru the Gorger"},
							{"Ruins of Ahn'Qiraj", "Ossirian the Unscarred"},
							{"The Temple of Ahn'Qiraj", "The Prophet Skeram"},
							{"The Temple of Ahn'Qiraj", "Lord Kri"},
							{"The Temple of Ahn'Qiraj", "Princess Yauj"},
							{"The Temple of Ahn'Qiraj", "Vem"},
							{"The Temple of Ahn'Qiraj", "Battleguard Sartura"},
							{"The Temple of Ahn'Qiraj", "Fankriss the Unyielding"},
							{"The Temple of Ahn'Qiraj", "Viscidus"},
							{"The Temple of Ahn'Qiraj", "Princess Huhuran"},
							{"The Temple of Ahn'Qiraj", "Emperor Vek'lor"},
							{"The Temple of Ahn'Qiraj", "Emperor Vek'nilash"},
							{"The Temple of Ahn'Qiraj", "Ouro"},
							{"The Temple of Ahn'Qiraj", "C'Thun"},
							{"Naxxramas", "Anub'Rekhan"},
							{"Naxxramas", "Grand Widow Faerlina"},
							{"Naxxramas", "Maexxna"},
							{"Naxxramas", "Noth the Plaguebringer"},
							{"Naxxramas", "Heigan the Unclean"},
							{"Naxxramas", "Loatheb"},
							{"Naxxramas", "Instructor Razuvious"},
							{"Naxxramas", "Gothik the Harvester"},
							{"Naxxramas", "The Four Horsemen"},
							{"Naxxramas", "Patchwerk"},
							{"Naxxramas", "Grobbulus"},
							{"Naxxramas", "Gluth"},
							{"Naxxramas", "Thaddius"},
							{"Naxxramas", "Sapphiron"},
							{"Naxxramas", "Kel'Thuzad"},
						}
		


local cglocal_stats = 	{ 	PlayedTime = 0, 
							Level = 0,
							GoldMade = 0,
							GoldLooted = 0,
							GoldHeld = 0,
							MaxRank = 0,
							HKs = 0,
							DKs = 0,
							Faction = "",
							Riding = 0
						}

local cglocal_toon = ""		-- toonName-realm
local cglocal_tabShown = 1	--tab currently being shown

local cglocal_realm = ""
local cglocal_faction = ""

-------------------------------------------------------------------------

function ClassicGoals_OnLoad()

	ClassicGoals_ContainerFrame:RegisterEvent("ADDON_LOADED");					--Initialisation
	ClassicGoals_ContainerFrame:RegisterEvent("PLAYER_ENTERING_WORLD");			--Toon Initialisation	

	ClassicGoals_ContainerFrame:RegisterEvent("PLAYER_MONEY");					--Money changes		
	ClassicGoals_ContainerFrame:RegisterEvent("CHAT_MSG_MONEY");				--Money is looted	
	ClassicGoals_ContainerFrame:RegisterEvent("CHAT_MSG_LOOT");					--item is looted/received/traded		
	ClassicGoals_ContainerFrame:RegisterEvent("TIME_PLAYED_MSG");				--Played Time		
	ClassicGoals_ContainerFrame:RegisterEvent("PLAYER_LEVEL_UP");				--Detect dings		
	ClassicGoals_ContainerFrame:RegisterEvent("UPDATE_FACTION");				--detect rep changes
	--ClassicGoals_ContainerFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");	--mob killed
	ClassicGoals_ContainerFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");		--HKs
	ClassicGoals_ContainerFrame:RegisterEvent("SPELLS_CHANGED");				--warlock and paladin mounts
	ClassicGoals_ContainerFrame:RegisterEvent("CHAT_MSG_SKILL");				--mount training
	ClassicGoals_ContainerFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")	

end

-------------------------------------------------------------------------

function ClassicGoals_OnEvent(event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg, arg9 = ...
	
	if event == "ADDON_LOADED" and arg1 == "ClassicGoals" then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff00ff[ClassicGoals]|r v."..cglocal_version.." by Cixi@Remulos. Type /ClassicGoals or /cg to get started,")
		--DEFAULT_CHAT_FRAME:AddMessage("or use the minimap button to toggle the app.")
		cglocal_loadTime = time()

		ClassicGoals_maintitle:SetText("ClassicGoals  v"..cglocal_version)

		cglocal_toon = UnitName("player") .. '-' .. GetRealmName()

		--check new install (all variables empty)
		if (ClassicGoals_ToonStats == nil) then ClassicGoals_ToonStats = {}; end
		if (ClassicGoals_ToonStats[cglocal_toon] == nil) then ClassicGoals_ToonStats[cglocal_toon] = cglocal_stats;	end
		if (ClassicGoals_ToonStats["Account"] == nil) then ClassicGoals_ToonStats["Account"] = cglocal_stats;	end
		if ClassicGoals_Selected == nil then ClassicGoals_Selected = {}; end
		if ClassicGoals_Selected["Account"] == nil then ClassicGoals_Selected["Account"] = {}; end
		if ClassicGoals_Selected[cglocal_toon] == nil then ClassicGoals_Selected[cglocal_toon] = {}; end
		
		
		-- starting ticker
		cglocal_ticker = C_Timer.NewTicker(cglocal_freq, ClassicGoals_UpdatePlayedTime )

		ClassicGoals_DisplayAdd()

		ClassicGoals_LoadCombo("Bosses", cglocal_bosses, "or select a Raid Boss")
		ClassicGoals_LoadCombo("Reps", cglocal_reputations, "Select a reputation")
		ClassicGoals_LoadCombo("RepLevels", cglocal_replevels, "and a reputation level")

		ClassicGoals_myTabPage3_version:SetText("Version "..cglocal_version)
		ClassicGoals_myTabPage3_note:SetText("Thanks for downloading |cFFFFd100ClassicGoals|r, we hope you'll like it.\n\n\n\nTo get started, click the |cFFFFD100Add New Goal|r tab at the bottom,\npick a new goal from the list and customize as you like.\nThe rest should be self-explanatory!")
	
	end

	

	if event == "PLAYER_ENTERING_WORLD" then
		-- set some defaults for the current toon
		ClassicGoals_ToonStats[cglocal_toon].Level = UnitLevel("player")
		ClassicGoals_ToonStats[cglocal_toon].Faction = UnitFactionGroup("player")
		ClassicGoals_ToonStats[cglocal_toon].Realm = GetRealmName()
		local honorableKills, dishonorableKills, highestRank = GetPVPLifetimeStats()
		ClassicGoals_ToonStats[cglocal_toon].HKs = honorableKills
		ClassicGoals_ToonStats[cglocal_toon].DKs = dishonorableKills
		ClassicGoals_ToonStats[cglocal_toon].MaxRank = highestRank
		ClassicGoals_ToonStats[cglocal_toon].GoldHeld = GetMoney()
		cglocal_moneyBefore = GetMoney()
		--RequestTimePlayed() -- update PlayedTime

		cglocal_realm = GetRealmName()
		cglocal_faction = UnitFactionGroup("player")

		ClassicGoals_CheckGoldMade(0)
		ClassicGoals_CheckGoldLooted(0)
		ClassicGoals_CheckGoldHeld()
		ClassicGoals_CheckLevels()
		ClassicGoals_CheckRep()
		ClassicGoals_CheckPlayedTime()
		ClassicGoals_CheckPVP()
		ClassicGoals_CheckMount()
		--ClassicGoals_CheckKill()
		ClassicGoals_CheckItem()
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
	end

	if event == "PLAYER_MONEY" then
		--print("Before: " ..cglocal_moneyBefore)
		--print("current: " ..GetMoney())
		cglocal_moneyAmount = GetMoney() - cglocal_moneyBefore
		--print("Diff: "..cglocal_moneyAmount)
		ClassicGoals_ToonStats[cglocal_toon].GoldMade = ClassicGoals_ToonStats[cglocal_toon].GoldMade + cglocal_moneyAmount
		ClassicGoals_ToonStats[cglocal_toon].GoldHeld = GetMoney()
		ClassicGoals_CheckGoldHeld()
		ClassicGoals_CheckGoldMade(cglocal_moneyAmount)
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
		cglocal_moneyBefore = GetMoney() --reset the total held
	end


	if event == "CHAT_MSG_MONEY" then
		-- moneyamount is calculated in PLAYER_MONEY which always trigger before this even
		ClassicGoals_ToonStats[cglocal_toon].GoldLooted = ClassicGoals_ToonStats[cglocal_toon].GoldLooted + cglocal_moneyAmount
		ClassicGoals_CheckGoldLooted(cglocal_moneyAmount)
		ClassicGoals_UpdateAccountStats()
	end


	if event == "CHAT_MSG_LOOT" then
		ClassicGoals_CheckItem()
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
	end


	if event == "PLAYER_LEVEL_UP" then
		ClassicGoals_ToonStats[cglocal_toon].Level = arg1
		ClassicGoals_CheckLevels()
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
	end

	if event == "UPDATE_FACTION" then
		ClassicGoals_CheckRep()
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
	end

	if event == "SPELLS_CHANGED" or event == "CHAT_MSG_SKILL" then
		local skill = 0
		for skillIndex = 1, GetNumSkillLines() do
			local skillName, _, _, skillRank = GetSkillLineInfo(skillIndex)
			if string.find(skillName, "Riding") or string.find(skillName, "Piloting") or string.find(skillName, "Horsemanship") then
				--print(string.format("Skill: %s - %s", skillName, skillRank))
				skill = skillRank
			end
		  end
		  
		if IsSpellKnown(13819, false) or IsSpellKnown(5784, false) then skill = 150 end  -- warhorse / felsteed
		if IsSpellKnown(23161, false) or IsSpellKnown(23214, false) then skill = 300 end   --dreadsteed / charger	
	
		ClassicGoals_ToonStats[cglocal_toon].Riding = tonumber(skill)
		
		ClassicGoals_CheckMount()
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
	end 
	
	if event == "PLAYER_PVP_KILLS_CHANGED" then
		local honorableKills, dishonorableKills, highestRank = GetPVPLifetimeStats()
		ClassicGoals_ToonStats[cglocal_toon].HKs = honorableKills
		ClassicGoals_ToonStats[cglocal_toon].DKs = dishonorableKills
		ClassicGoals_CheckPVP()
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
	end
	

	if event == "TIME_PLAYED_MSG" then
		-- totalTimePlayed, timePlayedThisLevel
		ClassicGoals_ToonStats[cglocal_toon].PlayedTime = arg1
		ClassicGoals_CheckPlayedTime()
		ClassicGoals_UpdateAccountStats()
		ClassicGoals_DisplayGoals()
		--print("time played" .. arg1)
	end

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		ClassicGoals_CheckKill(event)
		--ClassicGoals_DisplayGoals()   -can cause lag because of the numerous events in fight
	end

end

-------------------------------------------------------------------------

function ClassicGoals_LoadCombo(dropdownName, dataList, title) 


	local ClassicGoals_dropDown = nil

	-- Create the dropdown, and configure its appearance
	if _G["ClassicCombo_DropDown_"..dropdownName] == nil then 
		ClassicGoals_dropDown = CreateFrame("Frame", "ClassicCombo_DropDown_"..dropdownName, ClassicGoals_ScrollChildFrameAddOptions, "ClassicGoalsLib_UIDropDownMenuTemplate") 
		ClassicGoals_dropDown:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
		ClassicGoals_dropDown:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 400, yy)
	else 
		ClassicGoals_dropDown = _G["ClassicCombo_DropDown_"..dropdownName]
	end
	
	Lib_UIDropDownMenu_SetWidth(ClassicGoals_dropDown, 260)
	Lib_UIDropDownMenu_SetText(ClassicGoals_dropDown, title)
	ClassicGoals_dropDown:Hide()


	Lib_UIDropDownMenu_Initialize(ClassicGoals_dropDown, function(self, level, menuList)
		local info = Lib_UIDropDownMenu_CreateInfo() 
		if (level or 1) == 1 then
			local prevItem = ""
			-- Display the day groups
			for ib, b in ClassicGoals_Spairs(dataList, function(t,a,b) 	return a > b end) do
				if b[1] ~= prevItem then
					info.text = b[1]
					info.menuList = b[1]
					info.hasArrow = (dropdownName == "Bosses")
					if (dropdownName ~= "Bosses") then
						info.arg1 = ib
						info.func = self.SetValue 
					end
					Lib_UIDropDownMenu_AddButton(info, level)
					prevItem = b[1]
				end
			end

		else
			if dropdownName == "Bosses" then 
				--nested group
				for ib, b in ClassicGoals_Spairs(dataList, function(t,a,b) 	return a > b end) do
					if b[1] == menuList then 
						info.text = b[2]
						info.menuList = ib
						info.hasArrow = false
						info.arg1 = ib
						info.func = self.SetValue
						info.owner = frame
						Lib_UIDropDownMenu_AddButton(info, level)
					end
				end
			end
		end
	end)
	-- Implement the function to change the favoriteNumber
	function ClassicGoals_dropDown:SetValue(newValue)

		if newValue ~= nil then
			
			if dropdownName == "Bosses" then 
				cglocal_addgoal["YYY"] = dataList[newValue][2]
				cglocal_editYYY4:SetText(dataList[newValue][2])
			end

			if dropdownName == "Reps" then 
				cglocal_addgoal["XXX"] = dataList[newValue][1]	-- rep name
				Lib_UIDropDownMenu_SetText(ClassicGoals_dropDown, dataList[newValue][1])
			end 

			if dropdownName == "RepLevels" then 
				cglocal_addgoal["YYY"] = dataList[newValue][1]	-- rep level text
				cglocal_addgoal["ZZZ"] = dataList[newValue][2]  -- rep level value		
				Lib_UIDropDownMenu_SetText(ClassicGoals_dropDown, dataList[newValue][1])
			end 

			ClassicGoals_myTabPage2Options_save:SetEnabled(true)
		else 
			ClassicGoals_myTabPage2Options_save:SetEnabled(false)
		end
		Lib_CloseDropDownMenus()
	end
end

-------------------------------------------------------------------------

function ClassicGoals_UpdatePlayedTime()
	-- runs on a ticker
	ClassicGoals_ToonStats[cglocal_toon].PlayedTime = ClassicGoals_ToonStats[cglocal_toon].PlayedTime + cglocal_freq
	ClassicGoals_UpdateAccountStats()
	ClassicGoals_CheckPlayedTime()
	ClassicGoals_DisplayGoals()
end

-------------------------------------------------------------------------

function ClassicGoals_CheckMount() 
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then
		for id, what in pairs(goalsToCheck) do --loop on char and account

			--Checking Account and Character Goals
			if ClassicGoals_Selected[what] ~= nil then
				--print(what)
				for id, sel in pairs(ClassicGoals_Selected[what]) do
				
					-- 115: normal mount 
					if (sel.Goal == 115) then
						if (ClassicGoals_ToonStats[what].Riding >= 150 ) then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have the riding skill!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						end
					end

					-- 116: epic mount 
					if (sel.Goal == 116) then
						if (ClassicGoals_ToonStats[what].Riding >= 300 ) then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have the Epic riding skill!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						end
					end

					-- 11: Checking number of toons with normal riding 
					if (sel.Goal == 11) then
						local totalToons = 0
						for tid, toon in pairs(ClassicGoals_ToonStats) do
							if tid ~= "Account" then 
								if toon.Riding ~= nil and toon.Riding >= 150 then				
									totalToons = totalToons + 1
								end
							end
						end
						sel.ZZZ = totalToons
						if (sel.ZZZ >= sel.XXX) then 
							if sel.Achieved == false then 
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of having "..sel.XXX.." toons with the riding skill!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						end
					end

					-- 12: Checking number of toons with normal riding 
					if (sel.Goal == 12) then
						local totalToons = 0
						for tid, toon in pairs(ClassicGoals_ToonStats) do
							if tid ~= "Account" then 
								if toon.Riding ~= nil and toon.Riding >= 300 then				
									totalToons = totalToons + 1
								end
							end
						end
						sel.ZZZ = totalToons
						if (sel.ZZZ >= sel.XXX) then 
							if sel.Achieved == false then 
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of having "..sel.XXX.." toons with the Epic riding skill!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						end
					end					
				end
			end
		end
	end

end 

-------------------------------------------------------------------------

function ClassicGoals_CheckKill(event)
	local param1, param2, param3, param4, param5, param6, param7, param8, param9, param10, param11, param12, param13, param14, param15, param16 = CombatLogGetCurrentEventInfo()

	--party kill is the better option as it knows your group did the kill (your tag), but doesn't work in raid.
	--for raids, use UNIT_DIED, as since it's a raid mob your group obviously had the tag
	if (param2 == "PARTY_KILL" and not IsInRaid()) or (param2 == "UNIT_DIED" and IsInRaid()) then
		
--		print(param2.. "-"..param9)

		local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
		local goalsExist = false
	
		if ClassicGoals_Selected ~= nil then 
		
			--  check if goals exist
			for id, what in pairs(goalsToCheck) do
				if ClassicGoals_Selected[what] ~= nil then
					goalsExist = true
				end
			end
		end
	
		if goalsExist then
			for id, what in pairs(goalsToCheck) do --loop on char and account
	
	
				if ClassicGoals_Selected[what] ~= nil then -- check goals exist for char or account

					for id, sel in pairs(ClassicGoals_Selected[what]) do -- loop on those goals
			
						-- 106: kill boss 
						if (sel.Goal == 106) then
							if (param9 == sel.YYY) then				
								if sel.Achieved == false then  
									sel.Achieved = true
									print("|cffff00ff[ClassicGoals]|r Congratulations! You have defeated "..sel.YYY.."!")
									PlaySoundFile("sound/interface/pickup/putdownring.ogg")
								end
							end
						end

						-- 9 / 113: kill x mobs 
						if (sel.Goal == 113 or sel.Goal == 9) then
							if (sel.ZZZ == nil) then sel.ZZZ = 1 else sel.ZZZ = sel.ZZZ + 1 end
							if (sel.ZZZ >= sel.XXX) then				
								if sel.Achieved == false then  
									sel.Achieved = true
									print("|cffff00ff[ClassicGoals]|r Congratulations! You have killed "..sel.XXX.." mobs!")
									PlaySoundFile("sound/interface/pickup/putdownring.ogg")
								end
							end
						end

						-- 10 / 114: kill named mob x times 
						if (sel.Goal == 114 or sel.Goal == 10) then
							if (param9 == sel.YYY) then
								if (sel.ZZZ == nil) then sel.ZZZ = 1 else sel.ZZZ = sel.ZZZ + 1 end
								if (sel.ZZZ >= sel.XXX) then				
									if sel.Achieved == false then  
										sel.Achieved = true
										print("|cffff00ff[ClassicGoals]|r Congratulations! You have killed "..sel.YYY.." "..sel.XXX.." times!")
										PlaySoundFile("sound/interface/pickup/putdownring.ogg")
									end
								end
							end
						end
						
					end
				end
			end 
		end
	end 


	if param2 == "PARTY_KILL" then
	end

end

-------------------------------------------------------------------------

function ClassicGoals_CheckGoldMade(amount)
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then
		for id, what in pairs(goalsToCheck) do --loop on char and account

			if ClassicGoals_Selected[what] ~= nil then -- check goals exist for char or account

				for id, sel in pairs(ClassicGoals_Selected[what]) do -- loop on those goals
		
					-- 2 / 103: Checking gold made 
					if (sel.Goal == 2 or sel.Goal == 103) then
						if (sel.ZZZ == nil) then sel.ZZZ = amount else sel.ZZZ = sel.ZZZ + amount end
						if (sel.ZZZ >= (sel.XXX * 10000)) then				
						--if (ClassicGoals_ToonStats[what].GoldMade >= (sel.XXX * 10000)) then				
								if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of making "..sel.XXX.." gold!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of making "..sel.XXX.." gold.")
							end
							sel.Achieved = false 
						end
					end
				end
			end
		end
	end
end

-------------------------------------------------------------------------

function ClassicGoals_CheckGoldLooted(amount)
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then
		for id, what in pairs(goalsToCheck) do --loop on char and account

			--Checking Account and Character Goals
			if ClassicGoals_Selected[what] ~= nil then
				for id, sel in pairs(ClassicGoals_Selected[what]) do
				
					-- 3 / 104: Checking gold looted
					if (sel.Goal == 3 or sel.Goal == 104) then
						if (sel.ZZZ == nil) then sel.ZZZ = amount else sel.ZZZ = sel.ZZZ + amount end
						if (sel.ZZZ >= (sel.XXX * 10000)) then				
						--if (ClassicGoals_ToonStats[what].GoldLooted >= (sel.XXX * 10000)) then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of looting "..sel.XXX.." gold!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of looting "..sel.XXX.." gold.")
							end
							sel.Achieved = false 
						end
					end
				end
			end
		end 
	end 
end

-------------------------------------------------------------------------

function ClassicGoals_CheckGoldHeld()
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then
		for id, what in pairs(goalsToCheck) do --loop on char and account

			--Checking Account and Character Goals
			if ClassicGoals_Selected[what] ~= nil then
				for id, sel in pairs(ClassicGoals_Selected[what]) do
				
					-- 4 / 105: Checking gold held 
					if (sel.Goal == 4 or sel.Goal == 105) then
						if (ClassicGoals_ToonStats[what].GoldHeld >= (sel.XXX * 10000)) then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of having "..sel.XXX.." gold!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of having "..sel.XXX.." gold.")
							end
							sel.Achieved = false 
						end
					end
				end
			end
		end
	end 
end

-------------------------------------------------------------------------

function ClassicGoals_CheckLevels()
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then
		for id, what in pairs(goalsToCheck) do --loop on char and account

			--Checking Account and Character Goals
			if ClassicGoals_Selected[what] ~= nil then
				--print(what)
				for id, sel in pairs(ClassicGoals_Selected[what]) do
				
					-- 8: reach total levels
					if (sel.Goal == 8) then
						--print(ClassicGoals_ToonStats[what].Level)
						if (ClassicGoals_ToonStats[what].Level >= sel.XXX ) then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have leveled "..sel.XXX.." times!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else 
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of leveling "..sel.XXX.." times.")
							end
							sel.Achieved = false 								
						end
					end

					-- 101: reach level 
					if (sel.Goal == 101) then
						--print(ClassicGoals_ToonStats[what].Level)
						if (ClassicGoals_ToonStats[what].Level >= sel.XXX ) then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached level "..sel.XXX.."!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of reaching level "..sel.XXX..".")
							end
							sel.Achieved = false 
						end
					end

					-- 102: reach level under specified /played
					if (sel.Goal == 102) then
						if (ClassicGoals_ToonStats[what].Level >= sel.XXX ) then				
							--if (ClassicGoals_ToonStats[what].PlayedTime <= sel.YYY ) then 
								if sel.Achieved == false then  
									sel.Achieved = true
									print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached level "..sel.XXX.."!")
									PlaySoundFile("sound/interface/pickup/putdownring.ogg")
--								else
--									if sel.Achieved == true then
--										print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of reaching level "..sel.XXX..".")
--									end
--									sel.Achieved = false 
								end
							--end
						end
					end

					-- 1: Checking number of toons at level 
					if (sel.Goal == 1) then
						local totalToons = 0
						for tid, toon in pairs(ClassicGoals_ToonStats) do
							if tid ~= "Account" then 
								if (toon.Level >= sel.YYY ) then				
									totalToons = totalToons + 1
								end
							end
						end
						sel.ZZZ = totalToons
						if (sel.ZZZ >= sel.XXX) then 
							if sel.Achieved == false then 
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of having "..sel.XXX.." toons at level "..sel.YYY.."!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of having "..sel.XXX.." toons at level "..sel.YYY..".")
							end
							sel.Achieved = false 
						end
					end
				end
			end
		end
	end
end

-------------------------------------------------------------------------

function ClassicGoals_CheckRep()

	--Checking Account and Character Goals
	if ClassicGoals_Selected[cglocal_toon] ~= nil then
		for id, sel in pairs(ClassicGoals_Selected[cglocal_toon]) do
			-- 107: reach specific rep
			if (sel.Goal == 107) then
		
				local factionIndex = 1
				local lastFactionName = ""
				repeat
					local name, _, _, _, _, earnedValue = GetFactionInfo(factionIndex)
					if name == lastFactionName then break end
					lastFactionName  = name
					
					if (name == sel.XXX ) then
						ClassicGoals_Selected[cglocal_toon][id].earned = earnedValue
						--print(name.." - "..earnedValue)
						if (earnedValue >= sel.ZZZ ) then
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached "..sel.YYY.." status with "..sel.XXX.."!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else 
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your "..sel.YYY.." status with "..sel.XXX..".")
							end
							sel.Achieved = false 
						end
					end
					factionIndex = factionIndex + 1
		  		until factionIndex > 200
			end
		end
	end
end

-------------------------------------------------------------------------

function ClassicGoals_CheckPlayedTime()
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then
		for id, what in pairs(goalsToCheck) do --loop on char and account

			--Checking Account and Character Goals
			if ClassicGoals_Selected[what] ~= nil then
				for id, sel in pairs(ClassicGoals_Selected[what]) do
					-- 112: reach playtime amount
					if (sel.Goal == 5 or sel.Goal == 112) then

						local factor = 60 * 60	-- this is used to convert into seconds
						if sel.YYY == "days" then factor = 60 * 60 * 24 end

						if ClassicGoals_ToonStats[what].PlayedTime >= (sel.XXX * factor) then
							if sel.Achieved == false then  
								sel.Achieved = true
								if (sel.Goal == 112) then 
									print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached "..sel.XXX.." "..sel.YYY.." of playtime on this character!")
									PlaySoundFile("sound/interface/pickup/putdownring.ogg")
								else 
									print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached "..sel.XXX.." "..sel.YYY.." of playtime on this account!")
									PlaySoundFile("sound/interface/pickup/putdownring.ogg")
								end
							end
						end
					end
				end
			end 
		end
	end
end

-------------------------------------------------------------------------

function ClassicGoals_CheckPVP()
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then
		for id, what in pairs(goalsToCheck) do --loop on char and account

			--Checking Account and Character Goals
			if ClassicGoals_Selected[what] ~= nil then
				for id, sel in pairs(ClassicGoals_Selected[what]) do
				
					-- 6 / 110: Checking HKS 
					if (sel.Goal == 6 or sel.Goal == 110) then
				
						--print(sel.XXX)
						if ClassicGoals_ToonStats[what].HKs >= sel.XXX then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of having "..sel.XXX.." HKs!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of having "..sel.XXX.." HKs.")
							end
							sel.Achieved = false 
						end
					end
				
					-- 7 / 111: Checking DKS 
					if (sel.Goal == 7 or sel.Goal == 111) then
						if ClassicGoals_ToonStats[what].DKs >= sel.XXX then				
							if sel.Achieved == false then  
								sel.Achieved = true
								print("|cffff00ff[ClassicGoals]|r Congratulations! You have reached your goal of having "..sel.XXX.." DKs!")
								PlaySoundFile("sound/interface/pickup/putdownring.ogg")
							end
						else
							if sel.Achieved == true then
								print("|cffff00ff[ClassicGoals]|r Careful! You have just lost your goal of having "..sel.XXX.." DKs.")
							end
							sel.Achieved = false 
						end
					end
				end
			end
		end
	end 
end

-------------------------------------------------------------------------

function ClassicGoals_CheckItem()

	--Checking Account and Character Goals
	if ClassicGoals_Selected[cglocal_toon] ~= nil then
		for id, sel in pairs(ClassicGoals_Selected[cglocal_toon]) do
			-- 108: have a specific item
			if (sel.Goal == 108) then

				local bag, slot = ClassicGoals_GetBagPosition(sel.YYY 	)
				--print("slot "..slot)
				
				if slot ~= 0 or IsEquippedItem(sel.XXX) then
					if sel.Achieved == false then  
						sel.Achieved = true
						print("|cffff00ff[ClassicGoals]|r Congratulations! You obtained "..sel.YYY.."!")
						PlaySoundFile("sound/interface/pickup/putdownring.ogg")
					end
				end
			end
		end
	end
end

-------------------------------------------------------------------------

function ClassicGoals_GetBagPosition(itemLink)
    for bag = 0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
            if(GetContainerItemLink(bag, slot) == itemLink) then
                return bag, slot
            end
        end
	end
	return 0, 0
end
 



-------------------------------------------------------------------------

function ClassicGoals_UpdateAccountStats()

	local totalLevels = 0
	local totalGoldHeld = 0
	local totalGoldMade = 0
	local totalGoldLooted = 0
	local totalHKs = 0
	local totalDKs = 0
	local totalPlayedTime = 0

	for tid, toon in pairs(ClassicGoals_ToonStats) do
		if tid ~= "Account" then
			--	if cglocal_realm == toon.Realm and cglocal_faction == toon.Faction then
				totalLevels = totalLevels + toon.Level
				totalGoldMade = totalGoldMade + toon.GoldMade
				totalGoldLooted = totalGoldLooted + toon.GoldLooted
				totalGoldHeld = totalGoldHeld + toon.GoldHeld
				totalHKs = totalHKs + toon.HKs
				totalDKs = totalDKs + toon.DKs
				totalPlayedTime = totalPlayedTime + toon.PlayedTime
			--end
		end
	end
	ClassicGoals_ToonStats["Account"].Level = totalLevels
	ClassicGoals_ToonStats["Account"].GoldMade = totalGoldMade
	ClassicGoals_ToonStats["Account"].GoldLooted = totalGoldLooted
	ClassicGoals_ToonStats["Account"].GoldHeld = totalGoldHeld
	ClassicGoals_ToonStats["Account"].HKs = totalHKs
	ClassicGoals_ToonStats["Account"].DKs = totalDKs
	ClassicGoals_ToonStats["Account"].PlayedTime = totalPlayedTime

end

-------------------------------------------------------------------------

function ClassicGoals_DisplayGoals()
	
	local goalsToCheck = { "Account", cglocal_toon }  -- this is all we need to check
	local goalsExist = false

	if ClassicGoals_Selected ~= nil then 
	
		--  check if goals exist
		for id, what in pairs(goalsToCheck) do
			if ClassicGoals_Selected[what] ~= nil then
				goalsExist = true
			end
		end
	end

	if goalsExist then

		ClassicGoals_myTabPage1_nobody:Hide()
		ClassicGoals_ScrollFrame:Show()
	
		ClassicGoals_myTabPage1_accountGoals:Hide()
		ClassicGoals_myTabPage1_characterGoals:Hide()
	
		--Hiding all frames
		for i, f in pairs(cglocal_selectedframes) do
			_G[f]:Hide()
		end

		local ClassicGoals_yy = -10

		for id, what in pairs(goalsToCheck) do

			if ClassicGoals_Selected[what] ~= nil then
			
				--There are some goals, show the matching header
				if what == "Account" then 
					if ClassicGoals_Count(ClassicGoals_Selected[what]) > 0 then
						ClassicGoals_myTabPage1_accountGoals:Show()
						ClassicGoals_myTabPage1_accountGoals:SetParent(ClassicGoals_ScrollChildFrame)
						ClassicGoals_myTabPage1_accountGoals:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrame, "TOPLEFT", 40, ClassicGoals_yy); 
						ClassicGoals_yy = ClassicGoals_yy - 30
					end
				else  
					if ClassicGoals_Count(ClassicGoals_Selected[what]) > 0 then
						ClassicGoals_myTabPage1_characterGoals:Show()
						ClassicGoals_myTabPage1_characterGoals:SetParent(ClassicGoals_ScrollChildFrame)
						ClassicGoals_myTabPage1_characterGoals:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrame, "TOPLEFT", 40, ClassicGoals_yy);
						ClassicGoals_yy = ClassicGoals_yy - 30
					end
				end

		
		
				for id, sel in pairs(ClassicGoals_Selected[what]) do

					local goal 
					for gid, gg in pairs(cglocal_goals) do
						if gg.Id == sel.Goal then 
							goal = gg
						end
					end 

					if goal ~= nil then 
						-- let's find out if we need to create this groupframe or if we can reuse it
						local exist = false
						for _, f in ipairs(cglocal_selectedframes) do if f == "ClassicGoalsSelected_"..what.."_"..id then exist = true end end
						
						if exist == false then 
							CreateFrame("Button", "ClassicGoalsSelected_"..what.."_"..id, ClassicGoals_ScrollChildFrame, "ClassicGoals_SelectedTemplate")
							table.insert(cglocal_selectedframes, "ClassicGoalsSelected_"..what.."_"..id)
						
						end

						local desc = goal.Desc
						local title = goal.Title
						--print(title)
						if sel.XXX ~= nil then title = string.gsub(title, "XXX", "|cffffd100"..sel.XXX.."|r") end
						if sel.YYY ~= nil then title = string.gsub(title, "YYY", "|cffffd100"..sel.YYY.."|r") end
						if sel.ZZZ ~= nil then title = string.gsub(title, "ZZZ", "|cffffd100"..sel.ZZZ.."|r") end
						
						if sel.Achieved then
							title = "|cFF00FF00"..string.gsub(string.gsub(title, "|cffffd100", ""), "|r", "").."|r" 
							desc = "|cFF00FF00"..desc.."|r" 
					
							_G["ClassicGoalsSelected_"..what.."_"..id.."_status"]:SetNormalTexture("Interface\\AddOns\\ClassicGoals\\Images\\ok")
							_G["ClassicGoalsSelected_"..what.."_"..id.."_status"]:Show()
						else 
							_G["ClassicGoalsSelected_"..what.."_"..id.."_status"]:Hide();
						end 
						_G["ClassicGoalsSelected_"..what.."_"..id.."_icon"]:SetNormalTexture(goal.Icon);
						
						_G["ClassicGoalsSelected_"..what.."_"..id.."_title"]:SetText("" .. title)
						_G["ClassicGoalsSelected_"..what.."_"..id.."_desc"]:SetText("|cffc0c0c0"..desc.."|r")

						_G["ClassicGoalsSelected_"..what.."_"..id]:SetParent(ClassicGoals_ScrollChildFrame)
						_G["ClassicGoalsSelected_"..what.."_"..id]:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrame, "TOPLEFT", 40, ClassicGoals_yy);			
						_G["ClassicGoalsSelected_"..what.."_"..id]:Show()
						ClassicGoals_yy = ClassicGoals_yy - 50
					end
				end	
			end
			ClassicGoals_yy = ClassicGoals_yy - 20
				
		end
		ClassicGoals_ScrollChildFrame:SetHeight(-ClassicGoals_yy)
		ClassicGoals_ScrollChildFrame:SetWidth(676)	
		ClassicGoals_ScrollFrame:SetScrollChild(ClassicGoals_ScrollChildFrame)

	else
		ClassicGoals_myTabPage1_nobody:Show()
	end 

end 


-------------------------------------------------------------------------

function ClassicGoals_DisplayAdd()


	--Hiding all frames
	for i, f in pairs(cglocal_addframes) do
		_G[f]:Hide()
	end

	local ClassicGoals_yy = -10
	local type = ""

	for id, goal in pairs(cglocal_goals) do

		if (goal.Type ~= type) then 
			
			type = goal.Type

			--Show the goal header
			if type == "A" then 
				ClassicGoals_myTabPage2_addTitle:Show()
				ClassicGoals_myTabPage2_addTitle:SetParent(ClassicGoals_ScrollChildFrameAdd)
				ClassicGoals_myTabPage2_addTitle:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAdd, "TOPLEFT", 40, ClassicGoals_yy); 

				ClassicGoals_yy = ClassicGoals_yy - 20

				ClassicGoals_myTabPage2_addAccountGoals:Show()
				ClassicGoals_myTabPage2_addAccountGoals:SetParent(ClassicGoals_ScrollChildFrameAdd)
				ClassicGoals_myTabPage2_addAccountGoals:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAdd, "TOPLEFT", 40, ClassicGoals_yy); 
			else  
				ClassicGoals_yy = ClassicGoals_yy - 20
				ClassicGoals_myTabPage2_addCharacterGoals:Show()
				ClassicGoals_myTabPage2_addCharacterGoals:SetParent(ClassicGoals_ScrollChildFrameAdd)
				ClassicGoals_myTabPage2_addCharacterGoals:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAdd, "TOPLEFT", 40, ClassicGoals_yy);
			end
	
			ClassicGoals_yy = ClassicGoals_yy - 30
		end 
	
		-- let's find out if we need to create this groupframe or if we can reuse it
		local exist = false
		for _, f in ipairs(cglocal_addframes) do if f == "ClassicGoalsAdd_"..type.."_"..id then exist = true end end
		
		if exist == false then 
			CreateFrame("Button", "ClassicGoalsAdd_"..type.."_"..id, ClassicGoals_ScrollChildFrameAdd, "ClassicGoals_SelectedTemplate")
			table.insert(cglocal_addframes, "ClassicGoalsAdd_"..type.."_"..id)
		end

		local desc = goal.Desc
		local title = goal.Title
		if goal.XXX ~= nil then title = string.gsub(title, "XXX", "|cffffd100["..goal.XXX.."]|r") end
		if goal.YYY ~= nil then title = string.gsub(title, "YYY", "|cffffd100["..goal.YYY.."]|r") end
		if goal.ZZZ ~= nil then title = string.gsub(title, "ZZZ", "|cffffd100["..goal.ZZZ.."]|r") end
			
		_G["ClassicGoalsAdd_"..type.."_"..id.."_status"]:Hide();
		_G["ClassicGoalsAdd_"..type.."_"..id.."_edit"]:Hide();
		_G["ClassicGoalsAdd_"..type.."_"..id.."_delete"]:Hide();
		
		_G["ClassicGoalsAdd_"..type.."_"..id.."_icon"]:SetNormalTexture(goal.Icon);
			
		_G["ClassicGoalsAdd_"..type.."_"..id.."_title"]:SetText("" .. title)
		_G["ClassicGoalsAdd_"..type.."_"..id.."_desc"]:SetText("|cffc0c0c0"..desc.."|r")

		_G["ClassicGoalsAdd_"..type.."_"..id]:SetParent(ClassicGoals_ScrollChildFrameAdd)
		_G["ClassicGoalsAdd_"..type.."_"..id]:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAdd, "TOPLEFT", 40, ClassicGoals_yy);			
		_G["ClassicGoalsAdd_"..type.."_"..id]:Show()
		ClassicGoals_yy = ClassicGoals_yy - 50
		
		
		
			
	end
	ClassicGoals_ScrollChildFrameAdd:SetHeight(-ClassicGoals_yy)
	ClassicGoals_ScrollChildFrameAdd:SetWidth(676)	
	ClassicGoals_ScrollFrameAdd:SetScrollChild(ClassicGoals_ScrollChildFrameAdd)


end 

-------------------------------------------------------------------------

function ClassicGoals_DisplayAddOptions(goalId)

	cglocal_noTooltip = true
	cglocal_disableSave = false  -- allow the default value to not have to be validated

	--Hiding all frames
	for i, f in pairs(cglocal_addoptionsframes) do
		_G[f]:Hide()
	end

	local ClassicGoals_yy = -10
			
	--Show the options header
	ClassicGoals_myTabPage2Options_addTitle:Show()
	ClassicGoals_myTabPage2Options_addTitle:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
	ClassicGoals_myTabPage2Options_addTitle:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 40, ClassicGoals_yy); 

	ClassicGoals_yy = ClassicGoals_yy - 40

	local goal
	for i, g in pairs(cglocal_goals) do
		if (g.Id == goalId) then goal = g end
	end
	
	cglocal_noHighlighting = true --the goal is already selected
	cglocal_addgoal = {}
	cglocal_addgoal.Goal = goal.Id
	cglocal_addgoal.Type = goal.Type	
	
	-- let's find out if we need to create this groupframe or if we can reuse it
	local exist = false
	for _, f in ipairs(cglocal_addoptionsframes) do if f == "ClassicGoalsAddOptions_Goal" then exist = true end end

	if exist == false then 
		CreateFrame("Button", "ClassicGoalsAddOptions_Goal", ClassicGoals_ScrollChildFrameAddOptions, "ClassicGoals_SelectedTemplate")
		table.insert(cglocal_addoptionsframes, "ClassicGoalsAddOptions_Goal")
	end

	local desc = goal.Desc
	local title = goal.Title
	if goal.XXX ~= nil then title = string.gsub(title, "XXX", "|cffffd100["..goal.XXX.."]|r") end
	if goal.YYY ~= nil then title = string.gsub(title, "YYY", "|cffffd100["..goal.YYY.."]|r") end
	if goal.ZZZ ~= nil then title = string.gsub(title, "ZZZ", "|cffffd100["..goal.ZZZ.."]|r") end
	
	_G["ClassicGoalsAddOptions_Goal_status"]:Hide();
	_G["ClassicGoalsAddOptions_Goal_edit"]:Hide();
	_G["ClassicGoalsAddOptions_Goal_delete"]:Hide();

	_G["ClassicCombo_DropDown_Reps"]:Hide()
	_G["ClassicCombo_DropDown_RepLevels"]:Hide()
	_G["ClassicCombo_DropDown_Bosses"]:Hide()
	if cglocal_editYYY ~= nil then cglocal_editYYY:Hide() end 
	if cglocal_editYYY1 ~= nil then cglocal_editYYY1:Hide() end 
	if cglocal_editYYY2 ~= nil then cglocal_editYYY2:Hide() end 
	if cglocal_editYYY3 ~= nil then cglocal_editYYY3:Hide() end 
	if cglocal_editYYY4 ~= nil then cglocal_editYYY4:Hide() end 

	_G["ClassicGoalsAddOptions_Goal_icon"]:SetNormalTexture(goal.Icon);
	
	_G["ClassicGoalsAddOptions_Goal_title"]:SetText("" .. title)
	_G["ClassicGoalsAddOptions_Goal_desc"]:SetText("|cffc0c0c0"..desc.."|r")

	_G["ClassicGoalsAddOptions_Goal"]:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
	_G["ClassicGoalsAddOptions_Goal"]:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 40, ClassicGoals_yy);			
	_G["ClassicGoalsAddOptions_Goal"]:Show()

	ClassicGoals_yy = ClassicGoals_yy - 60

	_G["ClassicGoals_myTabPage2Options_addGoalType"]:SetText(goal.Type == "A" and "This is an |cffffd100Account-wide|r goal." or "This is a |cffffd100character-specific|r goal.")
	ClassicGoals_myTabPage2Options_addGoalType:Show()
	ClassicGoals_myTabPage2Options_addGoalType:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
	ClassicGoals_myTabPage2Options_addGoalType:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 40, ClassicGoals_yy); 
	
	ClassicGoals_yy = ClassicGoals_yy - 40

	if goal.Id ~= 115 and goal.Id ~= 116 then
		ClassicGoals_myTabPage2Options_addGoalCustomize:Show()
		ClassicGoals_myTabPage2Options_addGoalCustomize:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
		ClassicGoals_myTabPage2Options_addGoalCustomize:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 40, ClassicGoals_yy);
		
		ClassicGoals_yy = ClassicGoals_yy - 30
	else
		ClassicGoals_myTabPage2Options_addGoalCustomize:Hide()		
	end 




	if goal.XXX ~= nil then
		ClassicGoals_myTabPage2Options_XXX:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
		ClassicGoals_myTabPage2Options_XXX:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 60, ClassicGoals_yy); 
		ClassicGoals_myTabPage2Options_XXX:SetText("Enter a value for |cffffd100"..goal.XXX.."|r:")
		ClassicGoals_myTabPage2Options_XXX:Show()

		if (goal.Id ~= 106 and goal.Id ~= 107) then
			cglocal_editXXX = ClassicGoals_myTabPage2Options_editXXX_num
			cglocal_editXXX:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
			cglocal_editXXX:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 400, ClassicGoals_yy +5); 
			
			if cglocal_editselid == nil then
				cglocal_addgoal["XXX"] = goal.XXXdef
			else
				cglocal_addgoal["XXX"] = ClassicGoals_Selected[goal.Type == "A" and "Account" or cglocal_toon][cglocal_editselid].XXX
			end
			cglocal_editXXX:SetText(cglocal_addgoal["XXX"])
			cglocal_editXXX:Show()
		end


		-- this is for rep selection XXX
		if (goal.Id == 107) then

			if cglocal_editselid == nil then
				cglocal_addgoal["XXX"] = goal.XXXdef
			else
				cglocal_addgoal["XXX"] = ClassicGoals_Selected[cglocal_toon][cglocal_editselid].XXX
			end		
			Lib_UIDropDownMenu_SetText(_G["ClassicCombo_DropDown_Reps"], cglocal_addgoal["XXX"])
			_G["ClassicCombo_DropDown_Reps"]:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 380, ClassicGoals_yy +5)
			_G["ClassicCombo_DropDown_Reps"]:Show()
		end

		ClassicGoals_yy = ClassicGoals_yy - 30

	else 
		ClassicGoals_myTabPage2Options_XXX:Hide()
		if cglocal_editXXX ~= nil then cglocal_editXXX:Hide() end
		
	end




	if goal.YYY ~= nil then

		ClassicGoals_myTabPage2Options_YYY:SetParent(ClassicGoals_ScrollChildFrameAddOptions)

		if (goal.Id ~= 108) then
			ClassicGoals_myTabPage2Options_YYY:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 60, ClassicGoals_yy); 
			ClassicGoals_myTabPage2Options_YYY:SetText("Enter a value for |cffffd100"..goal.YYY.."|r:")
		else 
			ClassicGoals_myTabPage2Options_YYY:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 400, ClassicGoals_yy); 
			ClassicGoals_myTabPage2Options_YYY:SetText(goal.YYY)
			if cglocal_editselid == nil then
				ClassicGoals_myTabPage2Options_YYY:SetText(goal.YYYdef)
			else
				ClassicGoals_myTabPage2Options_YYY:SetText(ClassicGoals_Selected[cglocal_toon][cglocal_editselid].YYY)
			end
		end	
			
		ClassicGoals_myTabPage2Options_YYY:Show()
		

		-- this is for numeric YYY
		if (goal.Id == 1 or goal.Id == 102) then
			cglocal_editYYY = ClassicGoals_myTabPage2Options_editYYY_num
			cglocal_editYYY:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
			cglocal_editYYY:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 400, ClassicGoals_yy +5); 
			if cglocal_editselid == nil then
				cglocal_addgoal["YYY"] = goal.YYYdef
			else
				cglocal_addgoal["YYY"] = ClassicGoals_Selected[goal.Type == "A" and "Account" or cglocal_toon][cglocal_editselid].YYY
			end
			cglocal_editYYY:SetText(cglocal_addgoal["YYY"])
			cglocal_editYYY:Show()
		end

		-- this is for days/hours YYY
		if (goal.Id == 5 or goal.Id == 102 or goal.Id == 112) then
			cglocal_editYYY1 = ClassicGoals_myTabPage2Options_editYYY_dayshours1
			cglocal_editYYY1:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
			cglocal_editYYY1:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 390, ClassicGoals_yy +5); 
			_G["ClassicGoals_myTabPage2Options_editYYY_dayshours1Text"]:SetText("days")


			cglocal_editYYY2 = ClassicGoals_myTabPage2Options_editYYY_dayshours2
			cglocal_editYYY2:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
			cglocal_editYYY2:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 490, ClassicGoals_yy +5); 
			_G["ClassicGoals_myTabPage2Options_editYYY_dayshours2Text"]:SetText("hours")
			--cglocal_editYYY:SetText(goal.YYYdef)
			cglocal_addgoal["YYY"] = goal.YYYdef

			if cglocal_editselid == nil then
				cglocal_addgoal["YYY"] = goal.YYYdef
			else
				cglocal_addgoal["YYY"] = ClassicGoals_Selected[goal.Type == "A" and "Account" or cglocal_toon][cglocal_editselid].YYY
			end

			cglocal_editYYY1:SetChecked(cglocal_addgoal["YYY"] == "days")
			cglocal_editYYY2:SetChecked(cglocal_addgoal["YYY"] ~= "days")

			cglocal_editYYY1:Show()
			cglocal_editYYY2:Show()
		end

		-- this is for mob selection YYY
		if (goal.Id == 10 or goal.Id == 114 or goal.Id == 106) then
			cglocal_editYYY3 = ClassicGoals_myTabPage2Options_editYYY_target
			cglocal_editYYY3:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
			cglocal_editYYY3:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 560, ClassicGoals_yy +5); 
			cglocal_editYYY3:Show()

			cglocal_editYYY4 = ClassicGoals_myTabPage2Options_editYYY_mobname
			cglocal_editYYY4:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
			cglocal_editYYY4:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 400, ClassicGoals_yy); 
			if cglocal_editselid == nil then
				cglocal_addgoal["YYY"] = goal.YYYdef
			else
				cglocal_addgoal["YYY"] = ClassicGoals_Selected[goal.Type == "A" and "Account" or cglocal_toon][cglocal_editselid].YYY
			end
			cglocal_editYYY4:SetText(cglocal_addgoal["YYY"])
			cglocal_editYYY4:Show()

			--ClassicGoals_LoadCombo("ClassicCombo_DropDown_Bosses", cglocal_bosses, "or select a Raid Boss", 2, -100)
			--ClassicGoals_LoadCombo("ClassicCombo_DropDown_Reps", cglocal_reputations, "Select a reputation", 1, -200)
			--ClassicGoals_LoadCombo("ClassicCombo_DropDown_RepLevels", cglocal_replevels, "and a reputation level", 1, -300)

			ClassicGoals_yy = ClassicGoals_yy - 30

			_G["ClassicCombo_DropDown_Bosses"]:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 380, ClassicGoals_yy)
			_G["ClassicCombo_DropDown_Bosses"]:Show()
		end


		-- this is for rep selection YYY
		if (goal.Id == 107) then
			if cglocal_editselid == nil then
				cglocal_addgoal["YYY"] = goal.YYYdef
				cglocal_addgoal["ZZZ"] = goal.ZZZdef
			else
				cglocal_addgoal["YYY"] = ClassicGoals_Selected[cglocal_toon][cglocal_editselid].YYY
				cglocal_addgoal["ZZZ"] = ClassicGoals_Selected[cglocal_toon][cglocal_editselid].ZZZ
			end
			Lib_UIDropDownMenu_SetText(_G["ClassicCombo_DropDown_RepLevels"], cglocal_addgoal["YYY"])
			_G["ClassicCombo_DropDown_RepLevels"]:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 380, ClassicGoals_yy +5)
			_G["ClassicCombo_DropDown_RepLevels"]:Show()
		end


		ClassicGoals_yy = ClassicGoals_yy - 30

	else 
		ClassicGoals_myTabPage2Options_YYY:Hide()
		if cglocal_editYYY  ~= nil then cglocal_editYYY:Hide() end
		if cglocal_editYYY1 ~= nil then cglocal_editYYY1:Hide() end 
		if cglocal_editYYY2 ~= nil then cglocal_editYYY2:Hide() end 
		if cglocal_editYYY3 ~= nil then cglocal_editYYY3:Hide() end 
		if cglocal_editYYY4 ~= nil then cglocal_editYYY4:Hide() end 

		
	end


	ClassicGoals_myTabPage2Options_cancel:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
	ClassicGoals_myTabPage2Options_cancel:SetPoint("TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 60, ClassicGoals_yy); 
	
	ClassicGoals_myTabPage2Options_save:SetParent(ClassicGoals_ScrollChildFrameAddOptions)
	ClassicGoals_myTabPage2Options_save:SetPoint(  "TOPLEFT", ClassicGoals_ScrollChildFrameAddOptions, "TOPLEFT", 150, ClassicGoals_yy); 
	ClassicGoals_myTabPage2Options_save:SetEnabled(cglocal_editselid == nil)

	ClassicGoals_ScrollChildFrameAddOptions:SetHeight(-ClassicGoals_yy)
	ClassicGoals_ScrollChildFrameAddOptions:SetWidth(676)	
	ClassicGoals_ScrollFrameAddOptions:SetScrollChild(ClassicGoals_ScrollChildFrameAddOptions)

end 

-------------------------------------------------------------------------

function ClassicGoals_SetEditboxDisable(box)
	if cglocal_disableSave then ClassicGoals_myTabPage2Options_save:SetEnabled(false) end
	cglocal_disableSave = true
end

-------------------------------------------------------------------------

function ClassicGoals_SetEditbox(box, field)
	
	box:SetTextColor(1, 1, 1)
	local value = tonumber(box:GetNumber())
	if value and value > 0 then

		if cglocal_addgoal.Goal == 108 then   --special for item. we need to check it first
			local itemName, itemLink = GetItemInfo(value)
			if (itemName ~= nil and itemName ~= "") then
		--		print(itemName)
		--		print(itemLink)
				cglocal_addgoal.XXX = value
				cglocal_addgoal.YYY = itemLink
				cglocal_addgoal.ZZZ = itemName
				ClassicGoals_myTabPage2Options_YYY:SetText(itemLink)
				box:ClearFocus()
				ClassicGoals_myTabPage2Options_save:SetEnabled(true)
			else
				ClassicGoals_myTabPage2Options_YYY:SetText("Unknown item Id")
				ClassicGoals_myTabPage2Options_save:SetEnabled(false)
			end
		else
		cglocal_addgoal[field] = value
			--print("Setting value: "..cglocal_addgoal[field])
			box:ClearFocus()
			ClassicGoals_myTabPage2Options_save:SetEnabled(true)
		end
--	else
--		box:SetText(1)
--		box:HighlightText()
--		cglocal_addgoal[field] = 1
	end
end

-------------------------------------------------------------------------

function ClassicGoals_SetChecked(which, checked)

	cglocal_addgoal["YYY"] = which		
	ClassicGoals_myTabPage2Options_editYYY_dayshours1:SetChecked(which == "days")
	ClassicGoals_myTabPage2Options_editYYY_dayshours2:SetChecked(which == "hours")
	
end

-------------------------------------------------------------------------

function ClassicGoals_SelectTarget()
	local name = UnitName("target")
	if name ~= nil then
		cglocal_addgoal["YYY"] = name
		cglocal_editYYY4:SetText(name)
		ClassicGoals_myTabPage2Options_save:SetEnabled(true)
	else 
		ClassicGoals_myTabPage2Options_save:SetEnabled(false)
	end
end
-------------------------------------------------------------------------

function ClassicGoals_Save()

	local typeDest = "Account"
	if cglocal_addgoal.Type ~= "A" then typeDest = cglocal_toon end

	--print(cglocal_addgoal.Goal)
	--print(typeDest)
	--print(text)
	cglocal_addgoal.Type = nil
	cglocal_addgoal.Achieved = false
	--cglocal_addgoal.XXX = cglocal_editXXXval


	if (cglocal_addgoal.Goal == 9 or
		cglocal_addgoal.Goal == 10 or
		cglocal_addgoal.Goal == 11 or
		cglocal_addgoal.Goal == 12 or
		cglocal_addgoal.Goal == 113 or
		cglocal_addgoal.Goal == 114 or
		cglocal_addgoal.Goal == 106) then cglocal_addgoal.ZZZ = 0 end

	if (cglocal_addgoal.Goal == 107) then cglocal_addgoal["earned"] = 0 end
	if (cglocal_addgoal.Goal == 108) then 
--		print(cglocal_addgoal.XXX)
		local itemName, itemLink = GetItemInfo(cglocal_addgoal.XXX)
--		print(itemName)
--		print(itemLink)
		cglocal_addgoal.YYY = itemLink
		cglocal_addgoal.ZZZ = itemName 
	end
	
	cglocal_addgoal.StartDate = time()

	if ClassicGoals_Selected[typeDest] == nil then ClassicGoals_Selected[typeDest] = {} end
	
	if cglocal_editselid == nil then 
		table.insert(ClassicGoals_Selected[typeDest], cglocal_addgoal )
--		table.insert(ClassicGoals_Selected[typeDest], { Goal = cglocal_addgoal.Id, Achieved = false, XXX = cglocal_addgoal.XXX } )
	else
		ClassicGoals_Selected[typeDest][cglocal_editselid] = cglocal_addgoal
	end 

	ClassicGoals_CheckGoldMade(0)
	ClassicGoals_CheckGoldLooted(0)
	ClassicGoals_CheckGoldHeld()
	ClassicGoals_CheckLevels()
	ClassicGoals_CheckRep()
	ClassicGoals_CheckPlayedTime()
	ClassicGoals_CheckPVP()
	ClassicGoals_CheckItem()
	ClassicGoals_CheckMount()
	ClassicGoals_DisplayGoals()
	cglocal_noTooltip = false
	_G["ClassicGoals_myTabPage2Options"]:Hide()	
	ClassicGoals_ShowTab(1)

end

function ClassicGoals_Cancel() 
	ClassicGoals_ShowTab(cglocal_tabShown)
end

-------------------------------------------------------------------------

function ClassicGoals_Delete(self)

	if cglocal_noHighlighting ~= false then 
		--print(self:GetName())
		local s = ClassicGoals_Split(self:GetName(), "_")
		local typeLong = s[2]
		local selid = tonumber(s[3])
		ClassicGoals_Selected[typeLong][selid] = nil
		ClassicGoals_DisplayGoals()
		ClassicGoals_ShowTab(1)
	end
end

-------------------------------------------------------------------------

function ClassicGoals_Select(self)

	if cglocal_noHighlighting ~= true then 
		--print(self:GetName())
		local s = ClassicGoals_Split(self:GetName(), "_")
		local type = s[2]
		local goalid = tonumber(s[3])
		local typeDest = "Account"
		if type ~= "A" then typeDest = cglocal_toon end
		cglocal_editselid = nil
		--print("GoalId: "..goalid)
		ClassicGoals_GetParams(goalid, typeDest, true)
	end
end

-------------------------------------------------------------------------

function ClassicGoals_Edit(self)

	if cglocal_noHighlighting ~= false then 
		--print(self:GetName())
		local s = ClassicGoals_Split(self:GetName(), "_")
		local typeDest = s[2]
		local selid = tonumber(s[3])
		cglocal_editselid = selid
		--print("SelId:"..selid)
		ClassicGoals_GetParams(selid, typeDest, false)
	end
end

-------------------------------------------------------------------------

function ClassicGoals_GetParams(id, typeDest, insert)

	if insert then 
		ClassicGoals_DisplayAddOptions(cglocal_goals[id].Id)
	else
		ClassicGoals_DisplayAddOptions(ClassicGoals_Selected[typeDest][id].Goal)
	end

	cglocal_noTooltip = true
	_G["ClassicGoals_myTabPage1"]:Hide()
	_G["ClassicGoals_myTabPage2"]:Hide()
	_G["ClassicGoals_myTabPage2Options"]:Show()	
end

-------------------------------------------------------------------------

function ClassicGoals_Highlight(self)
	--_G[self:GetName().."_icon"]:SetNormalTexture("Interface\\AddOns\\ClassicGoals\\Images\\ok")
	if cglocal_noHighlighting ~= true then 
		_G[self:GetName().."_mask"]:Show() 
		_G[self:GetName().."_status"]:Show() 
	end
end
function ClassicGoals_Unhighlight(self)
	--_G[self:GetName().."_icon"]:SetNormalTexture("Interface\\AddOns\\ClassicGoals\\Images\\ok")
	if cglocal_noHighlighting ~= true then
		_G[self:GetName().."_mask"]:Hide()
		_G[self:GetName().."_status"]:Hide() 
	end
end

-------------------------------------------------------------------------

function ClassicGoals_Split(str, sep)
	
	local t = {}
	local ind = string.find(str, sep)
	while (ind ~= nil) do 	
		table.insert(t, string.sub(str, 1, ind-1))
		str = string.sub(str, ind+1)
		ind = string.find(str, sep, 1, true)
	end
	if (str ~="") then table.insert(t, str) end
	return t
	
end

-------------------------------------------------------------------------

function ClassicGoals_Count(tab)

	cglocal_count = 0
	for Index, Value in pairs(tab) do
		--DEFAULT_CHAT_FRAME:AddMessage("parsing: " .. Index)
		cglocal_count = cglocal_count + 1
	end
	--DEFAULT_CHAT_FRAME:AddMessage("Return: " .. cglocal_count)
	return cglocal_count
	
end

-------------------------------------------------------------------------

function ClassicGoals_Round(num, numDecimalPlaces)
	local mult = 10^(numDecimalPlaces or 0)
	return math.floor(num * mult + 0.5) / mult
end

-------------------------------------------------------------------------

function ClassicGoals_Spairs(t, order)
    -- collect the keys
    local keys = {}
    for k in pairs(t) do keys[ClassicGoals_Count(keys)+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys 
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end

-------------------------------------------------------------------------

function ClassicGoals_Stringify(tbl, sep)
	--[[
	local res
	for k, v in pairs(tbl) do
		res = res .. v .. sep
	end
	res = string.sub(res, 1, string.len(sub)-1)
	return res
	]]
end

-------------------------------------------------------------------------

function ClassicGoals_ShowTab(tab)
	
	for t = 1, 3 do
		_G["ClassicGoals_myTabPage" .. t]:Hide()
	end
	if tab ~= -1 then
		cglocal_tabShown = tab
		_G["ClassicGoals_myTabPage" .. cglocal_tabShown]:Show()
		PanelTemplates_SetTab(ClassicGoals_ContainerFrame, cglocal_tabShown);
	end 
	if tab == 1 then cglocal_noHighlighting = true else cglocal_noHighlighting = false end
	cglocal_noTooltip = false
	_G["ClassicGoals_myTabPage2Options"]:Hide()

	
	if tab == 1 then
			if ClassicGoals_Count(ClassicGoals_Selected) == 0 or (ClassicGoals_Count(ClassicGoals_Selected["Account"]) == 0 and ClassicGoals_Count(ClassicGoals_Selected[cglocal_toon]) == 0) then 
			_G["ClassicGoals_myTabPage1"]:Hide()
			_G["ClassicGoals_myTabPage3"]:Show()
		end
	end
end 

-------------------------------------------------------------------------

function ClassicGoals_AdjustScrollSizes() 

	local newHeight = ClassicGoals_ContainerFrame:GetHeight()
	-- -55 to adjust for tabs buttons
	ClassicGoals_ScrollFrame:SetHeight(newHeight - 45)
	ClassicGoals_ScrollFrameAdd:SetHeight(newHeight - 45)
	ClassicGoals_ScrollFrameAddOptions:SetHeight(newHeight - 45)

end

-------------------------------------------------------------------------

-- Put your code that you want on a minimap button click here.  arg1="LeftButton", "RightButton", etc
function ClassicGoals_MinimapButton_OnClick()

	if (ClassicGoals_ContainerFrame:IsShown()) then 
		ClassicGoals_ContainerFrame:Hide()
	else
		ClassicGoals_ContainerFrame:Show()
		ClassicGoals_ShowTab(1)
	end

end

-------------------------------------------------------------------------

function ClassicGoals_FormatGold(coppers, goldOnly)
	local g = 0
	local s = 0
	local c = 0
	local str = ""

	if coppers >= 100 then s = math.floor(coppers/100, 0); c = coppers - s*100; end
	if s >= 100 then g = math.floor(s/100, 0); s = s - g*100; end

	if (g > 0 or goldOnly == true) 					then str = str..g.."g " end
	if (g > 0 or s > 0 ) and (goldOnly == false) 	then str = str..s.."s " end
	if (goldOnly == false) 							then str = str..c.."c "	end
	return str
	
end

-------------------------------------------------------------------------

function ClassicGoals_FormatHours(seconds, hourOnly)
	local d = 0
	local h = 0
	local m = 0
	local s = 0
	local str = ""

	if seconds >= 60 then m = math.floor(seconds/60, 0); s = seconds - m*60; end
	if m >= 60 then h = math.floor(m/60, 0); m = m - h*60; end
	if h >= 24 then d = math.floor(h/24, 0); h = h - d*24; end

	if (d > 0 or hourOnly == true) 					then str = str..d.."day" end
	if (d > 1) 	then str = str.."s" end
	str = str.." "

	if (h > 0 or hourOnly == true) 					then str = str..h.."hr" end
	if (h > 1) 	then str = str.."s" end
	str = str.." "

	if (m > 0 or d > 0 ) and (hourOnly == false) 	then str = str..m.."min " end
	--if (hourOnly == false) 							then str = str..s.."sec "	end
	return str
	
end

-------------------------------------------------------------------------

-- normal tooltip for options
function ClassicGoals_ShowTooltip(self)

	if cglocal_noHighlighting == true and cglocal_noTooltip == false then 
		local s = ClassicGoals_Split(self:GetName(), "_")
		local typeDest = s[2]
		local id = tonumber(s[3])

		local goalId = ClassicGoals_Selected[typeDest][id].Goal
		local val1 = 1
		local val2 = 1
		local pref = ""
		local suff = ""
		local val1txt = ""
		local val2txt = ""


		if (goalId == 1)   then
			local str = ""
			local count = 0
			for tid, toon in ClassicGoals_Spairs(ClassicGoals_ToonStats, function(t,a,b) return ClassicGoals_ToonStats[a].Level > ClassicGoals_ToonStats[b].Level end) do
				if tid ~= "Account" then
					str = str..toon.Level..", "
				end
			end
			str = "("..string.sub(str, 1, string.len(str)-2)..")"
			val1 = ClassicGoals_Selected[typeDest][id].ZZZ
			val2 = ClassicGoals_Selected[typeDest][id].XXX
			pref = "You have"; 			suff = str;			val1txt = val1;			val2txt = val2;  
		end

		if (goalId == 8)   then val1 = ClassicGoals_ToonStats[typeDest].Level; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You have levelled"; 	suff = "times";				val1txt = val1; 										val2txt = val2;   end

		if (goalId == 101 or
			goalId == 102) then val1 = ClassicGoals_ToonStats[typeDest].Level; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You are level"; 	suff = "";				val1txt = val1; 										val2txt = val2;   end

		if (goalId == 2 or
			goalId == 103) then val1 = ClassicGoals_Selected[typeDest][id].ZZZ;		val2 = ClassicGoals_Selected[typeDest][id].XXX*10000; 		pref = "You made"; 			suff = "";				val1txt = ClassicGoals_FormatGold(val1, false); 		val2txt = ClassicGoals_FormatGold(val2, true);   end
		
		if (goalId == 3 or
			goalId == 104) then val1 = ClassicGoals_Selected[typeDest][id].ZZZ;		val2 = ClassicGoals_Selected[typeDest][id].XXX*10000; 		pref = "You looted"; 		suff = "";				val1txt = ClassicGoals_FormatGold(val1, false); 		val2txt = ClassicGoals_FormatGold(val2, true);   end
		
		if (goalId == 4 or
			goalId == 105) then val1 = ClassicGoals_ToonStats[typeDest].GoldHeld; 		val2 = ClassicGoals_Selected[typeDest][id].XXX*10000; 		pref = "You have"; 			suff = "";				val1txt = ClassicGoals_FormatGold(val1, false); 		val2txt = ClassicGoals_FormatGold(val2, true);   end
		
		if (goalId == 6 or
			goalId == 110) then val1 = ClassicGoals_ToonStats[typeDest].HKs; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You have"; 			suff = "HKs";			val1txt = val1;									 		val2txt = val2;   end

		if (goalId == 7 or
			goalId == 111) then val1 = ClassicGoals_ToonStats[typeDest].DKs; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You have"; 			suff = "DKs";			val1txt = val1;											val2txt = val2;   end

		if (goalId == 106) then val1 = (ClassicGoals_Selected[typeDest][id].Achieved and 1 or 0); 	val2 = 1; 			pref = "Kill status"; 		suff = "";				val1txt = val1; 										val2txt = val2;   end

		if (goalId == 107) then val1 = ClassicGoals_Selected[typeDest][id].earned; 		val2 = ClassicGoals_Selected[typeDest][id].ZZZ; 			pref = "Your rep is at";	suff = "";				val1txt = val1; 										val2txt = val2;   end

		if (goalId == 108) then val1 = (ClassicGoals_Selected[typeDest][id].Achieved and 1 or 0); 	val2 = 1; 			pref = "Item obtained"; 		suff = "";				val1txt = val1; 										val2txt = val2;   end

		if (goalId == 109) then val1 = ClassicGoals_ToonStats[typeDest].MaxRank; 		val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You are rank"; 		suff = "";				val1txt = val1; 										val2txt = val2;   end

		if (goalId == 110) then val1 = ClassicGoals_ToonStats[typeDest].HKs; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You have"; 			suff = "HKs";			val1txt = val1; 										val2txt = val2;   end

		if (goalId == 111) then val1 = ClassicGoals_ToonStats[typeDest].DKs; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You have"; 			suff = "DKs";			val1txt = val1; 										val2txt = val2;   end

		if (goalId == 5 or 
			goalId == 112) then 
				local factor = 60 * 60	-- this is used to convert into seconds
				if ClassicGoals_Selected[typeDest][id].YYY == "days" then factor = 60 * 60 * 24 end
				val1 = ClassicGoals_ToonStats[typeDest].PlayedTime; 	val2 = ClassicGoals_Selected[typeDest][id].XXX * factor;		pref = ""; 	suff = "";				val1txt = ClassicGoals_FormatHours(val1, false); 		val2txt = ClassicGoals_FormatHours(val2, true);   end
		

		if (goalId == 9 or
			goalId == 113) then val1 = ClassicGoals_Selected[typeDest][id].ZZZ; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You have killed"; 			suff = "mobs";			val1txt = val1;											val2txt = val2;   end
	
		if (goalId == 10 or
			goalId == 114) then val1 = ClassicGoals_Selected[typeDest][id].ZZZ; 			val2 = ClassicGoals_Selected[typeDest][id].XXX; 			pref = "You have killed "..ClassicGoals_Selected[typeDest][id].YYY; 			suff = "times";			val1txt = val1;											val2txt = val2;   end

		if (goalId == 115) then val1 = (ClassicGoals_Selected[typeDest][id].Achieved and 1 or 0); 	val2 = 1; 			pref = "Riding skill"; 		suff = "";				val1txt = val1; 										val2txt = val2;   end
		if (goalId == 116) then val1 = (ClassicGoals_Selected[typeDest][id].Achieved and 1 or 0); 	val2 = 1; 			pref = "Epic riding skill"; 		suff = "";				val1txt = val1; 										val2txt = val2;   end

		if (goalId == 11) then val1 = ClassicGoals_Selected[typeDest][id].ZZZ;		val2 = ClassicGoals_Selected[typeDest][id].XXX; 		pref = "You have"; 		suff = "toons with riding skill";				val1txt = val1; 		val2txt = val2; end
		if (goalId == 12) then val1 = ClassicGoals_Selected[typeDest][id].ZZZ;		val2 = ClassicGoals_Selected[typeDest][id].XXX; 		pref = "You have"; 		suff = "toons with Epic riding skill";				val1txt = val1; 		val2txt = val2; end



		if val1 == nil then val1 = 0 end -- just in case
		local percent = ClassicGoals_Round(val1 / val2 * 100, 2)
		
		GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT", 26, -72	)
		GameTooltip:AddLine(percent >= 100 and "Completed" or "Progress " .. percent .. "%")
		GameTooltip:AddLine(pref.." "..val1txt.." / "..val2txt.." "..suff, 1, 1, 1, 1)
		if ClassicGoals_Selected[typeDest][id].StartDate ~= nil then
			GameTooltip:AddLine("Started on "..date("%B %d, %Y at %H:%M", ClassicGoals_Selected[typeDest][id].StartDate),.6,.6,.6,1)
		end
		GameTooltip:Show()
	end

end 

-------------------------------------------------------------------------

function ClassicGoals_ToggleSound()
	--[[
	ClassicGoals_playSoundOnNewRequest = not ClassicGoals_playSoundOnNewRequest
	ClassicGoals_myTabPage3_playSoundOnNewRequest:SetChecked(ClassicGoals_playSoundOnNewRequest)
	if ClassicGoals_playSoundOnNewRequest then print("ClassicGoals: Notification sound ON") else print("ClassicGoals: Notification sound OFF") end
	]]
end

-------------------------------------------------------------------------

function ClassicGoals_SlashCommandHandler( msg )
	local args = ClassicGoals_Split(msg, " ")
		
	ClassicGoals_DisplayGoals()
	ClassicGoals_ContainerFrame:Show()
	ClassicGoals_ShowTab(1)
	
end

-------------------------------------------------------------------------

SlashCmdList["ClassicGoals"] = ClassicGoals_SlashCommandHandler
SLASH_ClassicGoals1 = "/ClassicGoals"
SLASH_ClassicGoals2 = "/cg"
